import { extend } from '../../../vue';
import { PROP_TYPE_BOOLEAN_STRING } from '../../../constants/props';
import { makeProp } from '../../../utils/props';

// --- Props ---

export var props = {
  stacked: makeProp(PROP_TYPE_BOOLEAN_STRING, false)
};

// --- Mixin ---

// @vue/component
export var stackedMixin = extend({
  props,
  computed: {
    isStacked() {
      var {
        stacked
      } = this;
      // `true` when always stacked, or returns breakpoint specified
      return stacked === '' ? true : stacked;
    },
    isStackedAlways() {
      return this.isStacked === true;
    },
    stackedTableClasses() {
      var {
        isStackedAlways
      } = this;
      return {
        'b-table-stacked': isStackedAlways,
        ["b-table-stacked-".concat(this.stacked)]: !isStackedAlways && this.isStacked
      };
    }
  }
});