import { isFunction } from './inspect';

// --- Static ---

export var from = function from() {
  return Array.from(...arguments);
};

// --- Instance ---

export var arrayIncludes = (array, value) => array.indexOf(value) !== -1;
export var concat = function concat() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  return Array.prototype.concat.apply([], args);
};

// --- Utilities ---

export var createArray = (length, fillFn) => {
  var mapFn = isFunction(fillFn) ? fillFn : () => fillFn;
  return Array.apply(null, {
    length
  }).map(mapFn);
};
export var flatten = array => array.reduce((result, item) => concat(result, item), []);
export var flattenDeep = array => array.reduce((result, item) => concat(result, Array.isArray(item) ? flattenDeep(item) : item), []);