import { extend } from '../vue';
import { cloneDeep } from './clone-deep';
import { looseEqual } from './loose-equal';
import { hasOwnProperty, keys } from './object';
var isEmpty = value => !value || keys(value).length === 0;
export var makePropWatcher = propName => ({
  handler(newValue, oldValue) {
    if (looseEqual(newValue, oldValue)) {
      return;
    }
    if (isEmpty(newValue) || isEmpty(oldValue)) {
      this[propName] = cloneDeep(newValue);
      return;
    }
    for (var key in oldValue) {
      if (!hasOwnProperty(newValue, key)) {
        this.$delete(this.$data[propName], key);
      }
    }
    for (var _key in newValue) {
      this.$set(this.$data[propName], _key, newValue[_key]);
    }
  }
});
export var makePropCacheMixin = (propName, proxyPropName) => extend({
  data() {
    return {
      [proxyPropName]: cloneDeep(this[propName])
    };
  },
  watch: {
    // Work around unwanted re-renders: https://github.com/vuejs/vue/issues/10115
    [propName]: makePropWatcher(proxyPropName)
  }
});