import { extend } from '../vue';
import { EVENT_NAME_INPUT } from '../constants/events';
import { PROP_TYPE_ANY } from '../constants/props';
import { makeProp } from './props';
export var makeModelMixin = function makeModelMixin(prop) {
  var {
    type = PROP_TYPE_ANY,
    defaultValue = undefined,
    validator = undefined,
    event = EVENT_NAME_INPUT
  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var props = {
    [prop]: makeProp(type, defaultValue, validator)
  };

  // @vue/component
  var mixin = extend({
    model: {
      prop,
      event
    },
    props
  });
  return {
    mixin,
    props,
    prop,
    event
  };
};