function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { isObject } from './inspect';

// --- Static ---

export var assign = function assign() {
  return Object.assign(...arguments);
};
export var create = (proto, optionalProps) => Object.create(proto, optionalProps);
export var defineProperties = (obj, props) => Object.defineProperties(obj, props);
export var defineProperty = (obj, prop, descriptor) => Object.defineProperty(obj, prop, descriptor);
export var freeze = obj => Object.freeze(obj);
export var getOwnPropertyNames = obj => Object.getOwnPropertyNames(obj);
export var getOwnPropertyDescriptor = (obj, prop) => Object.getOwnPropertyDescriptor(obj, prop);
export var getOwnPropertySymbols = obj => Object.getOwnPropertySymbols(obj);
export var getPrototypeOf = obj => Object.getPrototypeOf(obj);
export var is = (value1, value2) => Object.is(value1, value2);
export var isFrozen = obj => Object.isFrozen(obj);
export var keys = obj => Object.keys(obj);

// --- "Instance" ---

export var hasOwnProperty = (obj, prop) => Object.prototype.hasOwnProperty.call(obj, prop);
export var toString = obj => Object.prototype.toString.call(obj);

// --- Utilities ---

// Shallow copy an object
export var clone = obj => _objectSpread({}, obj);

// Return a shallow copy of object with the specified properties only
// See: https://gist.github.com/bisubus/2da8af7e801ffd813fab7ac221aa7afc
export var pick = (obj, props) => keys(obj).filter(key => props.indexOf(key) !== -1).reduce((result, key) => _objectSpread(_objectSpread({}, result), {}, {
  [key]: obj[key]
}), {});

// Return a shallow copy of object with the specified properties omitted
// See: https://gist.github.com/bisubus/2da8af7e801ffd813fab7ac221aa7afc
export var omit = (obj, props) => keys(obj).filter(key => props.indexOf(key) === -1).reduce((result, key) => _objectSpread(_objectSpread({}, result), {}, {
  [key]: obj[key]
}), {});

// Merges two object deeply together
// See: https://gist.github.com/Salakar/1d7137de9cb8b704e48a
export var mergeDeep = (target, source) => {
  if (isObject(target) && isObject(source)) {
    keys(source).forEach(key => {
      if (isObject(source[key])) {
        if (!target[key] || !isObject(target[key])) {
          target[key] = source[key];
        }
        mergeDeep(target[key], source[key]);
      } else {
        assign(target, {
          [key]: source[key]
        });
      }
    });
  }
  return target;
};

// Returns a shallow copy of the object with keys in sorted order
export var sortKeys = obj => keys(obj).sort().reduce((result, key) => _objectSpread(_objectSpread({}, result), {}, {
  [key]: obj[key]
}), {});

// Convenience method to create a read-only descriptor
export var readonlyDescriptor = () => ({
  enumerable: true,
  configurable: false,
  writable: false
});